/* FILE: myanisotropy.h            -*-Mode: c++-*-
 *
 * My Cubic Anisotropy, derived from Oxs_Energy class.
 *
 */

#ifndef _MY_ANISOTROPY
#define _MY_ANISOTROPY

#include "nb.h"
#include "threevector.h"
#include "energy.h"
#include "depkey.h"
#include "key.h"
#include "simstate.h"
#include "mesh.h"
#include "meshvalue.h"

/* End includes */

class My_Anisotropy:public Oxs_Energy {
private:
  REAL8m K1;
  REAL8m Ms;
  ThreeVector axis1;
  ThreeVector axis2;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  My_Anisotropy(const char* name,  // Child instance id
		Oxs_Director* newdtr, // App director
                Tcl_Interp* safe_interp, // Safe interpreter
                const char* argstr);  // MIF input block parameters

  virtual ~My_Anisotropy() {}

  virtual void GetEnergyAndField(const Oxs_SimState& state,
                                 Oxs_MeshValue<REAL8m>& energy,
                                 Oxs_MeshValue<ThreeVector>& field
                                 ) const;
};


#endif // _MY_ANISOTROPY
