/* FILE: tsfvectorfield.h      -*-Mode: c++-*-
 *
 * Tcl Script Fixed Vector Field, derived from Oxs_FixedVectorField class.
 *
 */

#ifndef _OXS_TSFVECTORFIELD
#define _OXS_TSFVECTORFIELD

#include "oc.h"

#include "fixedvectorfield.h"
#include "meshvalue.h"

/* End includes */

class Oxs_TSFVectorField:public Oxs_FixedVectorField {
private:
  UINT4m size; // Convenience variable, set from meshkey.
  Oxs_DepKey<Oxs_Mesh> meshkey;
  Oxs_MeshValue<ThreeVector> vec;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_TSFVectorField
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   Tcl_Interp* safe_interp, // Safe interpreter
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_TSFVectorField();

  virtual ThreeVector operator[](UINT4m index) const;
  // NB: This is a return by value! 
};


#endif // _OXS_TSFVECTORFIELD
