/* FILE: ucexchange.h            -*-Mode: c++-*-
 *
 * Uniform exchange energy on cubic mesh, derived from Oxs_Energy class.
 *
 */

#ifndef _OXS_UCEXCHANGE
#define _OXS_UCEXCHANGE

#include "depkey.h"
#include "energy.h"
#include "mesh.h"
#include "meshvalue.h"
#include "simstate.h"
#include "threevector.h"
#include "cubicmesh.h"

/* End includes */

class Oxs_UCExchange:public Oxs_Energy {
private:
  REAL8m Ms;
  REAL8m A;
  Oxs_DepKey<Oxs_CubicMesh> meshkey;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_UCExchange(const char* name,     // Child instance id
		 Oxs_Director* newdtr, // App director
                 Tcl_Interp* safe_interp, // Safe interpreter
		 const char* argstr);  // MIF input block parameters
  virtual ~Oxs_UCExchange();

  virtual void GetEnergyAndField(const Oxs_SimState& state,
                                 Oxs_MeshValue<REAL8m>& energy,
                                 Oxs_MeshValue<ThreeVector>& field
                                 ) const;
};


#endif // _OXS_UCEXCHANGE
