/* FILE: uniformfixedscalarfield.cc     -*-Mode: c++-*-
 *
 * Uniform Fixed Scalar Field, derived from Oxs_FixedScalarField class.
 *
 */

#include "oc.h"
#include "nb.h"

#include "uniformfixedscalarfield.h"

// Oxs_Ext registration support
OXS_EXT_REGISTER(Oxs_UniformFixedScalarField);

/* End includes */


// Constructor
Oxs_UniformFixedScalarField::Oxs_UniformFixedScalarField(
  const char* name,     // Child instance id
  Oxs_Director* newdtr, // App director
  Tcl_Interp* safe_interp, // Safe interpreter
  const char* argstr)   // MIF input block parameters
  : Oxs_FixedScalarField(name,newdtr,safe_interp,argstr)
{
  // Process arguments
  CheckInitValueParamCount("value",1);
  value=Nb_Atof((*FindInitValue("value"))[0].c_str());
  DeleteInitValue("value");

  VerifyAllInitArgsUsed();
}

BOOL Oxs_UniformFixedScalarField::Init()
{ return 1; }

Oxs_UniformFixedScalarField::~Oxs_UniformFixedScalarField()
{}
