/* FILE: uniformfixedscalarfield.h      -*-Mode: c++-*-
 *
 * Uniform Fixed Scalar Field, derived from Oxs_FixedScalarField class.
 *
 */

#ifndef _OXS_UNIFORMFIXEDSCALARFIELD
#define _OXS_UNIFORMFIXEDSCALARFIELD

#include "oc.h"

#include "fixedscalarfield.h"

/* End includes */

class Oxs_UniformFixedScalarField:public Oxs_FixedScalarField {
private:
  REAL8m value;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_UniformFixedScalarField
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   Tcl_Interp* safe_interp, // Safe interpreter
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_UniformFixedScalarField();

  virtual REAL8m operator[](UINT4m /* index */) const
  { return value; }
};


#endif // _OXS_UNIFORMFIXEDSCALARFIELD
