/* FILE: uniformfixedvectorfield.h      -*-Mode: c++-*-
 *
 * Uniform Fixed Vector Field, derived from Oxs_FixedVectorField class.
 *
 */

#ifndef _OXS_UNIFORMFIXEDVECTORFIELD
#define _OXS_UNIFORMFIXEDVECTORFIELD

#include "oc.h"

#include "fixedvectorfield.h"

/* End includes */

class Oxs_UniformFixedVectorField:public Oxs_FixedVectorField {
private:
  ThreeVector vec;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_UniformFixedVectorField
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   Tcl_Interp* safe_interp, // Safe interpreter
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_UniformFixedVectorField();

  virtual ThreeVector operator[](UINT4m /* index */) const
  { return vec; }
  // NB: This is a return by value! 
};


#endif // _OXS_UNIFORMFIXEDVECTORFIELD
