/* FILE: uzeeman.h            -*-Mode: c++-*-
 *
 * Uniform Zeeman (applied field) energy, derived from Oxs_Energy class.
 *
 */

#ifndef _OXS_UZEEMAN
#define _OXS_UZEEMAN

#include <vector>
#include "energy.h"
#include "threevector.h"

/* End includes */

class Oxs_UZeeman:public Oxs_Energy {
private:
  REAL8m Ms;
  vector<ThreeVector> Happ;  // Indexed off of state stage_number
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_UZeeman(const char* name,     // Child instance id
	      Oxs_Director* newdtr, // App director
              Tcl_Interp* safe_interp, // Safe interpreter
	      const char* argstr);  // MIF input block parameters
  virtual ~Oxs_UZeeman();

  virtual void GetEnergyAndField(const Oxs_SimState& state,
                                 Oxs_MeshValue<REAL8m>& energy,
                                 Oxs_MeshValue<ThreeVector>& field
                                 ) const;
};


#endif // _OXS_UZEEMAN
