/* FILE: energy.h                 -*-Mode: c++-*-
 *
 * Abstract energy class, derived from Oxs_Ext class.
 *
 */

#ifndef _OXS_ENERGY
#define _OXS_ENERGY

#include "ext.h"
#include "depkey.h"
#include "simstate.h"
#include "key.h"
#include "meshvalue.h"

/* End includes */

class Oxs_Energy:public Oxs_Ext {
protected:
  Oxs_Energy(const char* name,      // Child instance id
             Oxs_Director* newdtr); // App director
  Oxs_Energy(const char* name,
             Oxs_Director* newdtr,
             Tcl_Interp* safe_interp, // Safe interpreter
	     const char* argstr);   // MIF block argument string
public:

  // Field and energy calculation function.  This should be
  // "conceptually const."  The energy return is average energy
  // density for the corresponding cell, in J/m^3.  The field
  // is in A/m.
  virtual void GetEnergyAndField(const Oxs_SimState& state,
                                 Oxs_MeshValue<REAL8m>& energy,
                                 Oxs_MeshValue<ThreeVector>& field
                                 ) const =0;

  virtual ~Oxs_Energy();
};


#endif // _OXS_ENERGY
