/* FILE: evolver.h                 -*-Mode: c++-*-
 *
 * Abstract evolver class, derived from Oxs_Ext class.
 *
 */

#ifndef _OXS_EVOLVER
#define _OXS_EVOLVER

#include "driver.h"
#include "ext.h"
#include "key.h"

/* End includes */

class Oxs_Driver; // Forward reference

class Oxs_Evolver : public Oxs_Ext {
protected:
  Oxs_Evolver(const char* name,     // Child instance id
             Oxs_Director* newdtr); // App director
  Oxs_Evolver(const char* name,
             Oxs_Director* newdtr,
             Tcl_Interp* safe_interp, // Safe interpreter
	     const char* argstr);   // MIF block argument string
public:
  virtual ~Oxs_Evolver();

  virtual  BOOL
  Step(const Oxs_Driver& driver,
       Oxs_ConstKey<Oxs_SimState> current_state,
       Oxs_Key<Oxs_SimState>& next_state) = 0;
  // Returns true if step was successful, false if
  // unable to step as requested.

};

#endif // _OXS_EVOLVER
