/* FILE: fixedscalarfield.h      -*-Mode: c++-*-
 *
 * Abstract Oxs_ScalarFixedField class, derives from Oxs_Ext.
 * This is effectively an Oxs_Ext version of Oxs_MeshValue<REAL8m>.
 */

#ifndef _OXS_FIXEDSCALARFIELD
#define _OXS_FIXEDSCALARFIELD

#include "oc.h"

#include "ext.h"

/* End includes */

////////////////////////////////////////////////////////////////////////
// Oxs_FixedScalarField (generic Oxs_Ext scalar field) class
class Oxs_FixedScalarField : public Oxs_Ext {
protected:
  // Disable copy constructor and assignment operator by
  // declaring them here and never providing a definition.
  Oxs_FixedScalarField(const Oxs_FixedScalarField&);
  Oxs_FixedScalarField& operator=(const Oxs_FixedScalarField&);

  Oxs_FixedScalarField(const char* name,Oxs_Director* newdtr);
  Oxs_FixedScalarField(const char* name,Oxs_Director* newdtr,
                       Tcl_Interp* safe_interp,const char* argstr);
public:
  virtual ~Oxs_FixedScalarField() {}
  virtual REAL8m operator[](UINT4m index) const =0;
};


#endif // _OXS_FIXEDSCALARFIELD
