/* FILE: fixedvectorfield.h      -*-Mode: c++-*-
 *
 * Abstract Oxs_FixedVectorField class, derives from Oxs_Ext.
 * This is effectively an Oxs_Ext version of Oxs_MeshValue<ThreeVector>.
 */

#ifndef _OXS_FIXEDVECTORFIELD
#define _OXS_FIXEDVECTORFIELD

#include "oc.h"

#include "ext.h"
#include "threevector.h"

/* End includes */

////////////////////////////////////////////////////////////////////////
// Oxs_FixedVectorField (generic Oxs_Ext vector field) class
class Oxs_FixedVectorField : public Oxs_Ext {
protected:
  // Disable copy constructor and assignment operator by
  // declaring them here and never providing a definition.
  Oxs_FixedVectorField(const Oxs_FixedVectorField&);
  Oxs_FixedVectorField& operator=(const Oxs_FixedVectorField&);
  Oxs_FixedVectorField(const char* name,Oxs_Director* newdtr);
  Oxs_FixedVectorField(const char* name,Oxs_Director* newdtr,
                       Tcl_Interp* safe_interp,const char* argstr);

public:
  virtual ~Oxs_FixedVectorField() {}

  virtual ThreeVector operator[](UINT4m index) const =0;
  // NB: This is a return by value! 
};


#endif // _OXS_FIXEDVECTORFIELD
