/* FILE: autobuf.h                    -*-Mode: c++-*-
 *
 *	For converting string literals into the writable strings needed
 * as arguments to Tcl library calls.
 * 
 * NOTICE: Please see the file ../../LICENSE
 *
 * Last modified on: $Date: 2000/05/17 00:32:51 $
 * Last modified by: $Author: donahue $
 */

#ifndef _OC_AUTOBUF
#define _OC_AUTOBUF

#include <stddef.h>  // size_t definition

class Oc_AutoBuf
{
private:
  size_t bufsize; // Length of buffer pointed to by str. ( >= strlen(str)+1.)
  char *str;
  void Dup(const char* const_str);
public:
  Oc_AutoBuf();
  Oc_AutoBuf(const char* const_str);
  operator char*() const { return str; }
  char* operator()(const char* const_str);
  ~Oc_AutoBuf();
}; 

#endif /* _OC_AUTOBUF */
